//+------------------------------------------------------------------+
//|                           Copyright 2006, Pedz Rodulfo           |
//|                                          pedzr@yahoo.com         |
//+------------------------------------------------------------------+
//
// Uses ASCTrend & confirmations from LabTrend3 current TF & LT TF
// All settings maust match between EA & Indicators to allow correct chart views
// Or else trade signals will not align with chart indicators
//
// **Do not use on GBPJPY -- Huge slippage is a killer 6/6/06
// All externs set to match externs for ASCTrend & LabTrend3 6/6/06 V5
// Change MinStopLoss to 10 for M5 V5
// Ned to re-calc TP as preferred Risk:Reward ratio, Risk=initial stop loss V5.1 /6/7/06
// Change RR referenced to LabTrend trailingstop, not MinStopLoss V5.1 6/7/06
// Change -j to CompleteBars - 0 references incomplete bar & signal keeps flipping
//      causing multiple buys & sells 6/7/06
// Tighten complete bars to CompletedBars only to prevent re-entry using previous signal v5.3
//      to avoid whipsaws v5.3
// Add longterm Labtrend3 confirmation v6.0 & v6.1 6/8/06
// Change to ASC & Labtrend3 confirmations on Exit v6.2
// Default to time filter for now until range problems are solved. v6.2
// Clean-up & add RSI_Filter, NonLagMA, Pivots for SL/TP - setup by ND. v7.0 6/24/06
// Mini v7 - took out all Labtrend3 Stops for simplicity
// To be done - option to set fixed SL & TP


#property copyright "Copyright 2006, ASCTrend-Mini-m30 Setup by ND "
#property link      "pedzr@yahoo.com"

#define MAGIC 916888

//Option Setup
extern bool EnableCloseByASCTrend =true;
extern bool SignalOnLastBarOnly = true; //Trade on last 5 completed bar signal only, default = true
extern int CompleteBars = 5; //Check 5 completed bars only - increased to provide more ASCTrend leeway v6.1 6/8/06
extern bool EnableRSIFilterConfirm =true; //Confirmation by RSIFilter_v1
extern bool EnableNonLagMATrendv4 =true; //Confirmation by NonLAGMA4
extern bool UsePivotStop =true; //Use Pivot as Stop Loss (SL) - set permanently for now
extern bool UsePivotTarget =false; //Use Pivot as Target (TP)

extern bool UseHourTrade = false; //True = time filter ON
extern int FromHourTrade = 10; //NF Tme
extern int ToHourTrade = 24;
extern bool UseSound = false;
extern string NameFileSound = "alert.wav";

//Parameter Setup
extern double MinStopLoss = 20; //Set MinStop to default of 20 pips, set to 10 pips for M5
extern double FixedStopLoss = 20;
extern int ShiftBars = 1;
extern int Risk = 3; //Make sure to set other chart indicators to match
extern int ASCRisk = 1; 
extern int ASCCountBars = 100; 
extern int Slippage = 5;
extern double Lots = 0.1; //Changed to 0.1 for "safety"
extern int iMode = 0;
extern int ShiftSignal = 1; //Signal uses last completed bar
extern int ShiftStop = 0; //Stoploss placements use current bars

extern string _Parameters_b_Lots = "Settings of the lot size calculation module";
extern int LotsWayChoice  = 0;    // Lot size selection: Set to "fixed" for "safety"
                                  //  0-fixed lot size, 
                                  //  1-% from deposit, 
                                  //  2-fractional proportional, 
                                  //  3-fractional fixed lot size, 
extern int LotsPercent=1;   // % from deposit 
extern int LotsDeltaDepo=500;  // factor of deposit increase 
extern int LotsDepoForOne=500;  // deposit size for 1 mini lot 
extern int LotsMax=10000; // Max number of mini lots 

extern color clOpenBuy = Lime;
extern color clCloseBuy = Aqua;
extern color clOpenSell = Red;
extern color clCloseSell = Violet;
extern color clModiBuy = CLR_NONE;
extern color clModiSell = CLR_NONE;
extern string Name_Expert = "ASCTrendNDm30-v7.0";

int i = 0,j = 0;
double lStopLoss = 5000;
double sStopLoss = 5000;
double OpenlStopLoss = 5000;
double OpensStopLoss = 5000;
double lTakeProfit = 10000;
double sTakeProfit = 10000;
double lTrailingStop = 1000;
double sTrailingStop = 1000;
double lLT = 1000;
double sLT = 1000;
double trend = 0; //NonLagMA trend
double upbuffer=0, dnbuffer=0; //RSI filtered buffers

int init()
  {
  ObjectsDeleteAll(0,OBJ_ARROW);
  ObjectsDeleteAll(0,OBJ_HLINE);
  //---- Clear objects
  return;
  }
  
void deinit(){

}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

bool PS=false, PB=false;

int start(){//1

 //2 *** Use all completed bars until last signal is found
 if(!SignalOnLastBarOnly){ //2
   for(i=ShiftBars;i<Bars; i++){//3
      PS = AscTrendSignal(0,"DOWN",i,ASCCountBars,ASCRisk);
      PB = AscTrendSignal(0,"UP",i,ASCCountBars,ASCRisk);
      //Print("PS ",PS," PB ",PB);
         if(PS||PB){//4   -- Break if there is a signal
         break;
         }//4
      }//3
  }//2
 
 //2 *** Use last X completed bars
 if(SignalOnLastBarOnly){ //2 Actually 1-5 bars to give Labtrend time to line up
      for(j=1;j<CompleteBars; j++){//3 Check for signal for last n completed bars
      PS = AscTrendSignal(0,"DOWN",j,ASCCountBars,ASCRisk);
      PB = AscTrendSignal(0,"UP",j,ASCCountBars,ASCRisk);
      //Print("PS ",PS," PB ",PB);
         if(PS||PB){//4   -- Break if there is a signal
         break;
         }//4
      }//3
  }//2
 
 //2 *** Get NonLAGMA Confirmation
 if (EnableNonLagMATrendv4) { //2
   trend = iCustom(NULL,NULL,"NonLagMA_v4",0,100,0,1,1,0,0.0,4,ShiftSignal);
   PB = (PB && trend>0); //Get confirmed directions
   PS = (PS && trend<0); //Get confirmed directions
 } //2 
 
 //2 *** Get RSI_Filter Confirmation
 if (EnableRSIFilterConfirm) { //2
   upbuffer = iCustom(NULL,NULL,"RSIFilter_v1",9,0,ShiftSignal);
   dnbuffer = iCustom(NULL,NULL,"RSIFilter_v1",9,1,ShiftSignal);
   PB = (PB && upbuffer>0); //Get confirmed directions
   PS = (PS && dnbuffer<0); //Get confirmed directions
 } //2
 
 //2 *** Get Pivots
 if (UsePivotStop || UsePivotTarget) { //2
   sStopLoss = iCustom(NULL,NULL,"^Pivot_ResSup",0,0,ShiftSignal); //Resist
   sTrailingStop = sStopLoss;
   lStopLoss = iCustom(NULL,NULL,"^Pivot_ResSup",0,1,ShiftSignal); //Support
   lTrailingStop = lStopLoss;
   } //2
 if (!UsePivotStop && !UsePivotTarget) { //2 
   lStopLoss = Bid-FixedStopLoss*Point;
   lTrailingStop = lStopLoss;
   sStopLoss = Ask+FixedStopLoss*Point;
   sTrailingStop = sStopLoss;
   } //2
 
 Print("ConfirmedPS:",PS," sTrail:",sTrailingStop," sLT:",sLT," ConfirmedPB ",PB," lTrail:",lTrailingStop," lLT:",lLT," Trend: ",trend); 
 
 //Set trailing stops - must be at least "MinStopLoss" pips  
 if (PB) {//If Confirmed Direction is UP > 0, else -1
      Print("Bid-LTrail ",Bid-lTrailingStop, " MinPt ", MinStopLoss*Point); 
      if(Bid-lTrailingStop >= MinStopLoss*Point){
         lStopLoss = lTrailingStop;
         }
      else //Keep lStopLoss stop at 10 Point
         {
         lTrailingStop = lTrailingStop-MinStopLoss*Point;
         lStopLoss= lTrailingStop;
         } 
      }
      
 if (PS) {//If Confirmed Direction is DOWN > 0, else -1 
      Print("STrail-Ask ",sTrailingStop," ",Ask, " MinPt ", MinStopLoss*Point); 
      if(sTrailingStop-Ask >= MinStopLoss*Point){
         sStopLoss = sTrailingStop;
         }
      else //Keep sStopLoss at 10 points
         {
         sTrailingStop = sTrailingStop+MinStopLoss*Point;
         sStopLoss = sTrailingStop;
         } 
      }        
 Comment(i,j,"SigOnLast:",SignalOnLastBarOnly," PB:",PB," PS:",PS," lStp:",lTrailingStop," sStp:",sTrailingStop," MinStp:",MinStopLoss*Point," Trnd: ",trend," UpB: ",upbuffer," DnB: ", dnbuffer);

 if (UseHourTrade){//2
  if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)){//3
  Comment("Non-Trading Hours");
  return(0);
  }//3
 }//2
 if(Bars<100){//2
 Print("bars less than 100");
 return(0);
 }//2
 //if(lStopLoss<10){//2
 //Print("StopLoss less than 10");
 //return(0);
 //}//2
 if(lTakeProfit<10){
 Print("TakeProfit less than 10");
 return(0);
 }//2
 //if(sStopLoss<10){
 //Print("StopLoss less than 10");
 //return(0);
 //}//2
 if(sTakeProfit<10){//2
 Print("TakeProfit less than 10");
 return(0);
 }//2
     
 if(AccountFreeMargin()<(500*Lots)){//2
 Print("You are out of Money", AccountFreeMargin());
 return(0);
 }//2
 
 if (!ExistPositions()){//2
  if (PS){//3
  OpenSell();
  return(0);
  }//3    
  if (PB){//3
  OpenBuy();
  return(0);
  }//3    
 }//2

 if (ExistPositions()){//2

 //Print("lStop ",lTrailingStop," sStop ",sTrailingStop);
  if(OrderType()==OP_BUY){//3
   if(EnableCloseByASCTrend){//4
    if (PS){//5
    CloseBuy();
    return(0); 
    }//5
   }//4
  }//3  
  if(OrderType()==OP_SELL){//3
   if(EnableCloseByASCTrend){//4
    if (PB){//5
    CloseSell();
    return(0);
    }//5
   }//4
  }//3
  if (!PB || !PS) { //3 If no signal, modify trailingstops only
  TrailingPositionsBuy(lTrailingStop);
  TrailingPositionsSell(sTrailingStop);
  } //3
  return (0);
 }//2
}//1

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}
void TrailingPositionsBuy(double trailingStop) {
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {  
            if (OrderType()==OP_BUY) {
                  Print("OrdSL: ", OrderStopLoss(), " Bid: ",Bid, " SStop ",trailingStop);  
                  if (MathAbs(OrderStopLoss()-trailingStop)>3*Point) { ModifyStopLoss(trailingStop);} //Move trailing stop only if >3 pips             
            } 
         } 
      } 
   } 
} 
void TrailingPositionsSell(double trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) {  
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) { 
            if (OrderType()==OP_SELL) { 
                  Print("OrdSL: ", OrderStopLoss(), " Ask: ",Ask, " BStop ",trailingStop," Pt ",Point); 
                  if (MathAbs(OrderStopLoss()-trailingStop)>3*Point) { ModifyStopLoss(trailingStop);} //Move trailing stop only if >3 pips             
            } 
         } 
      } 
   } 
} 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   if (fm && UseSound) PlaySound(NameFileSound); 
} 

void CloseBuy() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void CloseSell() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossBuy();
   if (UsePivotTarget) {ldTake = GetTakeProfitBuy();}
   if (!UsePivotTarget) {ldTake = Ask+1000*Point;} 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenBuy); 
   Print("OrderSent !!!!!!!!"); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() {
Print("OpenSell"); 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossSell(); 
   if (UsePivotTarget) {ldTake = GetTakeProfitSell();}
   if (!UsePivotTarget) {ldTake = 0.0;} 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenSell); 
   Print("OrderSent !!!!!!!!"); 
   if (UseSound) PlaySound(NameFileSound); 
} 

string GetCommentForOrder(){
return(Name_Expert); 
} 


double GetSizeLot() { 
  double dLot; 
  if (LotsWayChoice==0) dLot=Lots; 

  // fixed % from deposit 
  if (LotsWayChoice==1) { 
    dLot=MathCeil(AccountFreeMargin()/10000*LotsPercent)/10; 
  } 

  // fractional proportional 
  if (LotsWayChoice==2) { 
    int k=LotsDepoForOne; 
    for (double i=2; i<=LotsMax; i++) { 
      k=k+i*LotsDeltaDepo; 
      if (k>AccountFreeMargin()) { 
        dLot=(i-1)/10; break; 
      } 
    } 
  } 

  // fractional fixed 
  if (LotsWayChoice==3) { 
    dLot=MathCeil((AccountFreeMargin()-LotsDepoForOne)/LotsDeltaDepo)/10; 
  } 

  if (dLot<0.1)  dLot=0.1;
  if (dLot>LotsMax) dLot=LotsMax;
   
  return(dLot);  
  }
   
double GetStopLossBuy() { 	return (lStopLoss);} 
double GetStopLossSell() { 	return(sStopLoss); }
double GetTakeProfitBuy() { return(sStopLoss);} //Set TP to max
double GetTakeProfitSell() { return(lStopLoss); } //Set TP to 0


//******************************************************************************************************
//bool AscTrendSignal(int TF, string Direction, int Shift=0 int Risk=3)
//Description: Determine of the moment of the signal receiving from the AscTrendSignal indicator.
//Settings: int TF - Timeframe,string Direction - Direction to enter. int Shift - which bar to look at, int Risk - settings of the indicator
//Returned value - True if the signal received, false if else.
//******************************************************************************************************
// !!!Please note: the custom indicator should be named as "ASCTrend"
// for the normal working function 
bool AscTrendSignal(int TF=0, string Direction="", int Shift=1, int ASCBars=100, int Risk=3){//1
double ASCval1, ASCval2;
 ASCval1 = iCustom(NULL,NULL,"ASCTrend",Risk,ASCBars,0,Shift);
 ASCval2 = iCustom(NULL,NULL,"ASCTrend",Risk,ASCBars,1,Shift);
 Print("ASC1-Dn ",ASCval1," ASC2-Up ",ASCval2);
 if (Direction == "UP"){//2
  if(ASCval2>0){//3  ASCval2x > 0 == UP
  Print("New Dir ",Direction);
  return(true);
  }//3
 }//2
 if (Direction == "DOWN"){//2
  if(ASCval1>0){//3 ASCval1 > 0 == DOWN
  Print("New Dir ",Direction);
  return(true);
  }//3
 }//2
}//1



//******************************************************************************************************
//bool LabTrend3(int TF, string Direction, int Shift=0 int Risk=3)
//Description: Set trailing stops.
//Settings: int TF - Timeframe,string Direction - Direction to enter. int Shift - which bar to look at, int Risk - settings of the indicator
//Returned value - True if the signal received, false if else.
//******************************************************************************************************
// !!!Please note: the custom indicator should be named as "LabTrend3"
// for the normal working function 
double LabTrend3Stop(int TF=0, int Risk=3, double MoneyRisk=2,int BarsNumber=1000,int iMode=0, int Shift=1){//1
double Stop;
Stop = iCustom(NULL,TF,"LabTrend3",Risk,MoneyRisk,BarsNumber,iMode,Shift);
return(Stop);
}

